package com.zcloud.controller.notice;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.corp.CorpInfoService;
import com.zcloud.service.notice.NoticeManagementService;
import com.zcloud.service.notice.NoticeTemplateService;
import com.zcloud.service.system.UsersService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：短信管理
 * 作者：luoxiaobao
 * 时间：2021-01-21
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/notice_management")
public class NoticeManagementController extends BaseController {

	@Autowired
	private NoticeManagementService noticemanagementService;

	@Autowired
	private NoticeTemplateService noticeTemplateService;

	@Autowired
	private CorpInfoService corpinfoService;

	@Autowired
    private UsersService usersService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "是否启用状态")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		if(null!=pd.getString("NOTICE_MANAGEMENT_ID")&&!"".equals(pd.getString("NOTICE_MANAGEMENT_ID"))) {
			PageData spd =	noticemanagementService.findById(pd);
			if(spd!=null) {
				if(spd.getString("ISENABLE").equals("1")) {
					pd.put("ISENABLE", "0");	//操作人
					noticemanagementService.editIsEnable(pd);
					PageData slpd = new PageData();
					slpd.put("ISENABLE", "1");
					slpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
					List<PageData>	varList = noticemanagementService.listAll(slpd);
					if(varList.size()<=0) {
						PageData cpd = new PageData();
						cpd.put("ISRECEIVE", "0");
						cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
						corpinfoService.editIsReceive(cpd);
					}
				}else {
					pd.put("ISENABLE", "1");	//操作人
					noticemanagementService.editIsEnable(pd);
					PageData cpd = new PageData();
					cpd.put("ISRECEIVE", "1");
					cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
					corpinfoService.editIsReceive(cpd);
				}

			}
		}else {
				PageData dpd =noticeTemplateService.findById(pd);
				pd.put("NOTICE_MANAGEMENT_ID", this.get32UUID());	//主键
				pd.put("NOTICE_NAME", dpd.getString("NAME"));	//操作人
				pd.put("NOTICE_CODE", dpd.getString("TEMPLATE_CODE"));	//操作人
				pd.put("NOTICE_TYPE", dpd.getString("NOTICETEMPLATE_ID"));	//操作人
				pd.put("ISENABLE", "1");	//操作人
				pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//操作人
				pd.put("OPDATE", DateUtil.date2Str(new Date()));	//操作日期
				pd.put("OPUSER", Jurisdiction.getUsername());	//操作人
				pd.put("ISDELETE", "0");	//是否删除
				pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
				pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改日期
				noticemanagementService.save(pd);
				PageData cpd = new PageData();
				cpd.put("ISRECEIVE", "1");
				cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
				corpinfoService.editIsReceive(cpd);
		}

		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		noticemanagementService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		noticemanagementService.edit(pd);
		map.put("result", errInfo);
		return map;
	}
	@RequestMapping(value="/editUserName")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "通过选择用户发送短信")
	public Object editUserName() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		if(null==pd.get("NOTICE_MANAGEMENT_ID") || "".equals(pd.getString("NOTICE_MANAGEMENT_ID"))) {
			PageData dpd =noticeTemplateService.findById(pd);
			pd.put("NOTICE_MANAGEMENT_ID", this.get32UUID());	//主键
			pd.put("NOTICE_NAME", dpd.getString("NAME"));	//操作人
			pd.put("NOTICE_CODE", dpd.getString("TEMPLATE_CODE"));	//操作人
			pd.put("NOTICE_TYPE", dpd.getString("NOTICETEMPLATE_ID"));	//操作人
			pd.put("ISENABLE", "0");	//操作人
			pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//操作人
			pd.put("OPDATE", DateUtil.date2Str(new Date()));	//操作日期
			pd.put("OPUSER", Jurisdiction.getUsername());	//操作人
			pd.put("ISDELETE", "0");	//是否删除
			pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
			pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改日期
			noticemanagementService.save(pd);
		}
		noticemanagementService.editUserName(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		page.setPd(pd);
		List<PageData>	varList = noticemanagementService.list(page);	//列出NoticeManagement列表
		PageData cpd = new PageData();
		cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		cpd=corpinfoService.findById(cpd);
		if(cpd!=null) {
			map.put("cpd", cpd);
		}

		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}
	@RequestMapping("/userlist")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "配置列表")
	public Object listUsers(Page page)throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();

		/*检索条件*/
		String KEYWORDS = pd.getString("USER_KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("USER_KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		pd.put("VIPLEVEL", Jurisdiction.getVIPLEVEL());
		page.setPd(pd);
		List<PageData>	userList = usersService.userlistPage(page);		//列出用户列表
		PageData spd =	noticemanagementService.findById(pd);
		List<PageData>	checkuserList =new ArrayList<PageData>();
		if(spd!=null) {
			if(null!=spd.getString("ADDRESSEE")&&!"".equals(spd.getString("ADDRESSEE"))) {
				checkuserList =usersService.listUserBYids(spd.getString("ADDRESSEE").split(","));

			}
		}
		map.put("checkuserList", checkuserList);
		map.put("userList", userList);

		map.put("page", page);
		map.put("pd", pd);

		map.put("result", errInfo);
		return map;
	}
	@RequestMapping(value="/checkuserList")
	@ResponseBody
	public Object checkuserList() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		PageData spd =	noticemanagementService.findById(pd);
		List<PageData>	checkuserList =new ArrayList<PageData>();
		if(spd!=null) {
			if(null!=spd.getString("ADDRESSEE")&&!"".equals(spd.getString("ADDRESSEE"))) {
				checkuserList =usersService.listUserBYids(spd.getString("ADDRESSEE").split(","));

			}
		}
		map.put("checkuserList", checkuserList);
		map.put("result", errInfo);
		return map;
	}
	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = noticemanagementService.findById(pd);	//根据ID读取
		List<PageData>	varList = noticeTemplateService.listAll(pd);
		corpinfoService.listAll(pd);
		map.put("pd", pd);
		map.put("pd", varList);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			noticemanagementService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	@LogAnno(menuType= "综合管理",menuServer= "通知公告",instructionsOperate = "通知模板配置",instructionsType = "导出到excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("名称");	//1
		titles.add("编码");	//2
		titles.add("类型");	//3
		titles.add("收信人");	//4
		titles.add("是否启用");	//5
		titles.add("企业ID");	//6
		titles.add("操作日期");	//7
		titles.add("操作人");	//8
		titles.add("是否删除");	//9
		titles.add("修改人");	//10
		titles.add("修改日期");	//11
		dataMap.put("titles", titles);
		List<PageData> varOList = noticemanagementService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("NOTICE_NAME"));	    //1
			vpd.put("var2", varOList.get(i).getString("NOTICE_CODE"));	    //2
			vpd.put("var3", varOList.get(i).getString("NOTICE_TYPE"));	    //3
			vpd.put("var4", varOList.get(i).getString("ADDRESSEE"));	    //4
			vpd.put("var5", varOList.get(i).getString("ISENABLE"));	    //5
			vpd.put("var6", varOList.get(i).getString("CORPINFO_ID"));	    //6
			vpd.put("var7", varOList.get(i).getString("OPDATE"));	    //7
			vpd.put("var8", varOList.get(i).getString("OPUSER"));	    //8
			vpd.put("var9", varOList.get(i).getString("ISDELETE"));	    //9
			vpd.put("var10", varOList.get(i).getString("OPERATOR"));	    //10
			vpd.put("var11", varOList.get(i).getString("OPERATTIME"));	    //11
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
